cd "C:\Shazam\AER"
log using "RINSFACD-2-out", replace
* AER VC SFA model and CIs
version 11
clear
set more off
set maxiter 200
import excel "StataData_RIN.xlsx", sheet("Sheet1") firstrow
summarize
correlate Energy CustNum CircLen RMDemand

generate DNSP=0
replace DNSP=int(EIID/100)

xtset DNSP YEAR

* adjust to calendar year
generate yr=YEAR
replace yr=yr+0.5 if DNSP==3
replace yr=yr+0.5 if DNSP==8
replace yr=yr+0.5 if DNSP==9
replace yr=yr+0.5 if DNSP==11
replace yr=yr+0.5 if DNSP==13

* adjust base to 2012
replace PrOpex=PrOpex/1.242220559

generate vc=Opex/PrOpex
generate lvc=log(vc)

generate uc1=vc/Energy
generate uc2=vc/CustNum
generate uc3=vc/CircLen
generate uc4=vc/RMDemand
generate obs=DNSP*10+YEAR-2004
*scatter uc1 obs, saving(uc1)
*scatter uc2 obs, saving(uc2)
*scatter uc3 obs, saving(uc3)
*scatter uc4 obs, saving(uc4)

generate ly1=log(Energy)
generate ly2=log(CustNum)
generate ly3=log(CircLen)
generate ly4=log(RMDemand)

generate z1=ShareUGC
generate z2=ShareSST
generate z3=CustMOS

generate cap=DistTran 

generate lz1=log(z1)
generate lz2=log(z2)
generate lz3=log(z3)

*generate lcap=log(cap)
*generate lcap=log(DistTran)

* mean correct output data
qui reg ly1
predict mly1
replace ly1=ly1-mly1
qui reg ly2
predict mly2
replace ly2=ly2-mly2
qui reg ly3
predict mly3
replace ly3=ly3-mly3
qui reg ly4
predict mly4
replace ly4=ly4-mly4

set matsize 1000
matrix bh=e(b)
matlist bh
mkmat ly1
mkmat ly2
mkmat ly3
mkmat ly4
generate c=1
mkmat c

matrix bh3=e(b)
matlist bh3
matrix e1=c*0
matrix e2=c*bh3[1,1]+ly1*0+ly2*bh3[1,4]+ly3*bh3[1,5]+ly4*bh3[1,6]
matrix e3=c*bh3[1,2]+ly1*0+ly2*bh3[1,5]+ly3*bh3[1,7]+ly4*bh3[1,8]
matrix e4=c*bh3[1,3]+ly1*0+ly2*bh3[1,6]+ly3*bh3[1,8]+ly4*bh3[1,9]
matrix elas = e1, e2, e3, e4

xtfrontier lvc ly2-ly4 lz1 yr, ti cost 
predict ci,te
frontier_teci ci
generate ceff=1/ci
generate ceff_l=1/ci_u
generate ceff_u=1/ci_l
list DNSP YEAR ceff ceff_l ceff_u
summarize DNSP YEAR ceff ceff_l ceff_u

log close
